Scriptname SLHH_Upkeep extends Quest  

SLHH_MCM Property MCM auto
SexLabFramework Property SexLab Auto
ReferenceAlias Property Aggressor auto
ReferenceAlias Property ThirdOne auto
ReferenceAlias Property companion auto
Quest Property SLHH_companion auto
int property iCount auto hidden

Event OnInit()
	RegisterForModEvent("StageStart_More", "HeWantsMore")
	RegisterForModEvent("AnimationEnd_More", "Finished")
EndEvent

Function Action()
iCount = 0
sslBaseAnimation[] anims
sslBaseAnimation[] animsCompanion
actor[] sexActorsCompanion
actor[] sexActors
actor NPC
int random = Utility.RandomInt(0, 100)

if MCM.Companion == true
	SLHH_Companion.Start()
endif
if random <= mcm.threesome
	NPC = SexLab.FindAvailableActor(CenterRef = Game.GetPlayer(), Radius = 2048.0, FindGender = 0, IgnoreRef1 = Game.GetPlayer(), IgnoreRef2 = Aggressor.GetActorRef(), IgnoreRef3 = Companion.GetActorRef(), IgnoreRef4 = none)
	ThirdOne.ForceRefTo(NPC)
	If NPC != none
		sexActors = new actor[3]
		sexActors[0] = Game.GetPlayer()
		sexActors[1] = Aggressor.GetRef() as Actor
		sexActors[2] = NPC
		
		If MCM.anim == "Leitos-Bound"
			anims = SexLab.GetAnimationsByTags(3, "Leito, Binding", "FFM")
		else
			anims = SexLab.GetAnimationsByTags(3, "Aggressive", "FFM")
		endif	
			
	else
		sexActors = new actor[2]
		sexActors[0] = Game.GetPlayer()
		sexActors[1] = Aggressor.GetRef() as Actor
		
		If MCM.anim == "Sleeping/Necro"
			anims = SexLab.GetAnimationsByTags(2, "Sleeping")
		elseIf MCM.anim == "Leitos-Bound"
			anims = SexLab.GetAnimationsByTags(2, "Leito, Binding")
		else
			anims = SexLab.GetAnimationsByTags(2, "Aggressive")
		endif	
	endif
else
		sexActors = new actor[2]
		sexActors[0] = Game.GetPlayer()
		sexActors[1] = Aggressor.GetRef() as Actor

		If MCM.anim == "Sleeping/Necro"
			anims = SexLab.GetAnimationsByTags(2, "Sleeping")
		elseIf MCM.anim == "Leitos-Bound"
			anims = SexLab.GetAnimationsByTags(2, "Leito, Binding")
		else
			anims = SexLab.GetAnimationsByTags(2, "Aggressive")
		endif
endif

SexLab.StartSex(sexActors, anims, victim=Game.GetPlayer(), allowBed=false, hook="More")
return
endFunction

Event HeWantsMore(string eventName, string argString, float argNum, form sender)
sslThreadController thread = SexLab.HookController("HeWantsMore")
If iCount > 0 && iCount < 4
	If (iCount == 1 && Utility.RandomInt(0, 100) <= MCM.StageChance) || (iCount == 2 && Utility.RandomInt(0, 100) <= (MCM.StageChance * 0.67)) || (iCount == 3 && Utility.RandomInt(0, 100) <= (MCM.StageChance * 0.34))
		thread.AdvanceStage(true)
		Debug.Notification("Your harasser wants some more!")
		iCount += 1
	endif
else
	iCount += 1
endif
endEvent

Event Finished(string eventName, string argString, float argNum, form sender)
If SLHH_Companion.isRunning() == true
	SLHH_Companion.Stop()
endif
SetStage(150)
endEvent

Event OnUpdateGameTime()
Utility.Wait(0.1)
If GetStage() == 150
	SetStage(160)
endif
EndEvent